var auto_shutdown_options = {
	notifiy: function (id, msg, type) {
		document.getElementById("notificationbox1").removeAllNotifications("true"); //Remove all notifications;  
		document.getElementById("notificationbox3").removeAllNotifications("true"); //Remove all notifications;  
		
		if (id == "notificationbox1")
		  document.getElementById("Sd.Option").showPane(document.getElementById("manage_pane")); //Switch to first tab
		else
		  document.getElementById("Sd.Option").showPane(document.getElementById("commands_pane")); //Switch to third tab
		
		var notificationbox = document.getElementById(id);		
		var msg_type;
		
		switch (type) {
		case "error": 
		  msg_type = notificationbox.PRIORITY_CRITICAL_BLOCK;
		  break;
		case "warning": 
		  msg_type = notificationbox.PRIORITY_INFO_MEDIUM;		
		}
		
		notificationbox.appendNotification(msg, '', '', msg_type);
	},
	
	saveAll: function() {
		auto_shutdown_options_pref.WriteStr('Time',document.getElementById('Sd.Option.txtSec').value);
		auto_shutdown_options_pref.WriteStr('TimeBeforeStart',document.getElementById('Sd.Option.txtbSec').value);
		auto_shutdown_options_pref.WriteBool('ClearAll',document.getElementById('Sd.Option.ChClear').checked);
		auto_shutdown_options_pref.WriteBool('ForceToExit',document.getElementById('Sd.Option.ForceToExit').checked);
		auto_shutdown_options_pref.WriteBool('Resume',document.getElementById('Sd.Option.Resume').checked);
		auto_shutdown_options_pref.WriteBool('StatusIconHide',document.getElementById('Sd.Option.HideStatustIcon').checked);
		auto_shutdown_options_pref.WriteBool('StatusCounterHide',document.getElementById('Sd.Option.HideStatustCounter').checked);
		auto_shutdown_options_pref.WriteBool('dlmgHide',document.getElementById('Sd.Option.Hidedlmg').checked);
		auto_shutdown_options_pref.WriteStr ('sndMode',document.getElementById('Sd.Option.sndMode').selectedIndex);
		auto_shutdown_options_pref.WriteBool('supportDTA',document.getElementById('Sd.Option.SupportDTA').checked);
		
		var index = document.getElementById('Sd.Option.radiogroup').selectedIndex;
		if (index == 0)
			auto_shutdown_options_pref.WriteStr ('ShellCMD4',document.getElementById('Sd.Option.txtShCommand').value);
		else
			auto_shutdown_options_pref.WriteStr ('ShellCMD4-IDLE',document.getElementById('Sd.Option.txtShCommand').value);
		
		//use to make sure time not changed
		auto_shutdown_options_pref.ReadStr('deactivateIDE');
		auto_shutdown_options_pref.WriteStr('IDEDelay',document.getElementById('Sd.Option.txtSecIDE').value);
		auto_shutdown_options_pref.WriteBool('IDETest',document.getElementById('Sd.Option.ShutdownOnIDE').checked);
		
		var stringsBundle = document.getElementById("Sd.options.Bundle");
		/*                         Test Command Format                     */
		String.prototype.trim = function () {
			return this.replace(/^\s*/, "").replace(/\s*$/, "");
		}
		var file = Components.classes["@mozilla.org/file/directory_service;1"]
				.getService(Components.interfaces.nsIProperties)
				
		var tolook =auto_shutdown_options_pref.ReadStr('ShellCMD4');
		/*                                 (begin) Repalce definitions                      */
		defArray=["ProgF", "WinD", "DeskV", "Progs", "Cntls", "Prnts", "Pers", "Favs", "Strt", "Rcnt", "SndTo", "Buckt", "Strt", "Trsh", "Strt", "Shdwn", "ApplMenu", "CntlPnl", "Exts", "Fnts", "Prfs", "Docs", "ISch", "DfltDwnld", "ULibDir", "UsrDsk", "LocDsk", "UsrApp", "LocApp", "UsrDocs", "LocDocs", "UsrIntrntPlgn", "LoclIntrntPlgn", "UsrFrmwrks", "LocFrmwrks", "UsrPrfs", "LocPrs", "Pct", "Mov", "Music", "IntrntSts"];

		for each (toremove in defArray){
			toremoveE="%"+toremove+"%";
			
			if(tolook.indexOf(toremoveE)!=-1){
				var re = new RegExp(toremoveE, 'g');
				tolook = tolook.replace(re, file.get(toremove , Components.interfaces.nsIFile).path);
			}
		}
		if(tolook.indexOf("%sysRoot%")!=-1){
			var re = new RegExp("%sysRoot%", 'g');
			
			var Client_OS = platform=navigator.platform;
			var appVer=window.navigator.oscpu;
			
			file= file.get("WinD" , Components.interfaces.nsIFile);

			if( (appVer.indexOf('98')>=0) || (appVer.indexOf('95')>=0) || (appVer.indexOf('Me')>=0) ){
				cmdPath=file.path ;
			}
			if ((appVer.indexOf('NT')>=0) || (appVer.indexOf('NT 5.0')>=0) ){
				cmdPath=file.path + '\\System32';
			} 

			if ((appVer.indexOf('NT 5.1')>=0) || (appVer.indexOf('NT 6')>=0)){ 
				cmdPath=file.path + '\\System32';
			}			
			tolook = tolook.replace(re, cmdPath);
		}
		/*                                 (end) Repalce definitions                      */
		/*                                 (begin) Seperate Commands                 */

		var aCommands=new Array();
		var aCommanders=new Array();
		var aCounter=0;

		var startCommander,endCommander,startCommand,endCommand=0;


		for(;startCommander!=-1 & endCommander!=-1 & startCommand!=-1 & endCommand!=-1;)
		{
			tolook=tolook.substr(startCommand+endCommand+endCommander+startCommander+5);
			startCommander = tolook.search("<");
			temp=tolook.substr(startCommander+1);
			endCommander   = temp.search(">");
			temp=temp.substr(endCommander+1);
			startCommand   = temp.search("</");
			temp=temp.substr(startCommand+2);
			endCommand     = temp.search(">");
			
			if(startCommander!=-1 & endCommander!=-1 & startCommand!=-1 & endCommand!=-1)
			{
				commander1=tolook.substr(startCommander+1,endCommander);
				commander2=tolook.substr(startCommand+endCommander+startCommander+4,endCommand);
				command=tolook.substr(startCommander+commander1.length+2,startCommand);
				if (commander1.substr(0,5)!=commander2.substr(0,5))
				{
					this.notifiy("notificationbox3", stringsBundle.getString('Error1'), "error");
					return;
				}
				else
				{
					aCommanders[aCounter]=commander1.trim();
					aCommands[aCounter++]=command;
				}
			}
			else if(startCommander!=-1 | endCommander!=-1 | startCommand!=-1 | endCommand!=-1)
			{
				this.notifiy("notificationbox3", stringsBundle.getString('Error2'), "error");
				return;
			}
		}
		/*                                 (end) Seperate Commands                 */
		/*                                 (begin) execute commands                */
		for(i=0;i<aCounter;i++){
			if(aCommanders[i].toLowerCase().substr(0,6)=="shell:"){
				try{
					var Location = Components.classes["@mozilla.org/file/local;1"]
								 .createInstance(Components.interfaces.nsILocalFile);
					Location.initWithPath(aCommanders[i].substr(6));
					
					// create an nsIProcess
					var process = Components.classes["@mozilla.org/process/util;1"]
											.createInstance(Components.interfaces.nsIProcess);
					process.init(Location);
				
					var args =new Array();
					// Run the process.
					var Commander=aCommands[i].trim().replace(/(\s+\n*)/g,' ').split(' ');  // replace  convert multi line command to one line command, split convert string to array
					for each (a in Commander)
						args[args.length]=a;
					//process.run(false, args, args.length);
				}
				catch(err){
					this.notifiy("notificationbox3", stringsBundle.getString('Error4') + '\n\n' + err.message, "error");
					return;
				}
			}
			else if(aCommanders[i].toLowerCase()=="javascript"){
				try{
					//eval(aCommands[i]);
				}
				catch(err){
					this.notifiy("notificationbox3", stringsBundle.getString('Error4') + '\n\n' + err.message, "error");
					return;
				}				
			}
			else{
				this.notifiy("notificationbox3", stringsBundle.getString('Error3'), "error");
				return;
			}
		}
		/*                        (end) Test Command Format                     */
		
		this.notifiy("notificationbox1", stringsBundle.getString('Alert12'), "warning");
	},
	initFields: function() {
		document.getElementById('Sd.Option.txtSec').value=auto_shutdown_options_pref.ReadStr('Time');
		document.getElementById('Sd.Option.txtbSec').value=auto_shutdown_options_pref.ReadStr('TimeBeforeStart');
		document.getElementById('Sd.Option.ChClear').checked=auto_shutdown_options_pref.ReadBool('ClearAll');
		document.getElementById('Sd.Option.ForceToExit').checked=auto_shutdown_options_pref.ReadBool('ForceToExit');
		document.getElementById('Sd.Option.Resume').checked=auto_shutdown_options_pref.ReadBool('Resume');
		document.getElementById('Sd.Option.HideStatustIcon').checked=auto_shutdown_options_pref.ReadBool('StatusIconHide');
		document.getElementById('Sd.Option.HideStatustCounter').checked=auto_shutdown_options_pref.ReadBool('StatusCounterHide');
		document.getElementById('Sd.Option.Hidedlmg').checked=auto_shutdown_options_pref.ReadBool('dlmgHide');
		document.getElementById('InBasic.Sd.Option.G2.OS14.id').value=auto_shutdown_options_pref.ReadStr('UserCMD1');
		document.getElementById('InBasic.Sd.Option.G2.OS15.id').value=auto_shutdown_options_pref.ReadStr('UserCMD2');
		document.getElementById('Sd.Option.sndMode').selectedIndex=auto_shutdown_options_pref.ReadStr('sndMode');
		document.getElementById('Sd.Option.txtSecIDE').value=auto_shutdown_options_pref.ReadStr('IDEDelay');
		document.getElementById('Sd.Option.ShutdownOnIDE').checked=auto_shutdown_options_pref.ReadBool('IDETest');
		document.getElementById('Sd.Option.SupportDTA').checked=auto_shutdown_options_pref.ReadBool('supportDTA');		
		
		auto_shutdown_options.change_status_of_idle(auto_shutdown_options_pref.ReadBool('IDETest'));		
		
		var stringsBundle = document.getElementById("Sd.options.Bundle");
		if(auto_shutdown_options_pref.ReadStr('ShellCMD4'))
			document.getElementById('Sd.Option.txtShCommand').value=auto_shutdown_options_pref.ReadStr('ShellCMD4');
		else
			this.notifiy("notificationbox1", stringsBundle.getString('Alert13'), "error");
	},
	
	change_status_of_idle: function(checked) {
		if (checked) {
			document.getElementById('Sd.Option.lblIDE1').disabled = false;
			document.getElementById('Sd.Option.txtSecIDE').disabled = false;
			document.getElementById('Sd.Option.lblIDE2').disabled = false;
		}
		else {
			document.getElementById('Sd.Option.lblIDE1').disabled = true;
			document.getElementById('Sd.Option.txtSecIDE').disabled = true;
			document.getElementById('Sd.Option.lblIDE2').disabled = true;
		}	
	},
	
	change_shutdown_command: function(index) {
		if (index == 0)
			document.getElementById('Sd.Option.txtShCommand').value = auto_shutdown_options_pref.ReadStr('ShellCMD4');
		else
			document.getElementById('Sd.Option.txtShCommand').value = auto_shutdown_options_pref.ReadStr('ShellCMD4-IDLE');
	},
	
	SaveUserCommand: function(commandnumber) {
		if(commandnumber==1){
			auto_shutdown_options_pref.WriteStr('UserCMD1',document.getElementById('Sd.Option.txtShCommand').value);
			document.getElementById('InBasic.Sd.Option.G2.OS14.id').value=document.getElementById('Sd.Option.txtShCommand').value;
		}
		else{
			auto_shutdown_options_pref.WriteStr('UserCMD2',document.getElementById('Sd.Option.txtShCommand').value);
			document.getElementById('InBasic.Sd.Option.G2.OS15.id').value=document.getElementById('Sd.Option.txtShCommand').value;
		}
	},
	downloadRequired: function() {
		//This function will be overwrite by showCommandPreview
	},
	showCommandPreview: function(value, selectedIndex) {
		var type = document.getElementById('Sd.Option.lstOs').childNodes[0].childNodes[selectedIndex].getAttribute('type');
		document.getElementById('Sd.Option.txtCommands').value=value;

		//Check to see if Cygwin's shutdown tool is installed or not		
		//Retrive extensions path
		var cygwin = function () {
			var em = Components.classes["@mozilla.org/extensions/manager;1"].
					 getService(Components.interfaces.nsIExtensionManager);
			var extensionDir = em.getInstallLocation("amin.eft_Shutdown@gmail.com").getItemFile("amin.eft_Shutdown@gmail.com", "");

			var file = Components.classes["@mozilla.org/file/local;1"].
								 createInstance(Components.interfaces.nsILocalFile);
			//Check to see if both of files are available or not
			file.initWithPath(extensionDir.path + "\\chrome\\executable\\sd.exe");			
			var temp = true; //Presume they are both available
			try { file.isFile(); } catch (e) {temp = false}
			file.initWithPath(extensionDir.path + "\\chrome\\executable\\cygwin1.dll");
			try { file.isFile(); } catch (e) {temp = false}
			
			return {	
						isInstalled:  temp,
						path: extensionDir.path + "\\chrome\\executable"
			}
		}();		
		var stringsBundle = document.getElementById("Sd.options.Bundle");
		if (type == "Cygwin" && !cygwin.isInstalled) {						
			document.getElementById('Sd.Option.setButton').disabled = true;
			document.getElementById('Sd.Option.IMG').src = "chrome://inbshutdown/skin/error.png";
			this.downloadRequired = function () {
				alert(stringsBundle.getString('notification1') + "\n" +
					  "http://downloads.mozdev.org/inbasic/CygwinShutdown.zip" + "\n\n" +
					  stringsBundle.getString('notification2') + "\n" +
					  cygwin.path);
			};
			this.downloadRequired();
		}
		else {
			if (type == "Linux")
				alert (stringsBundle.getString('Alert8') + "\n\t" + stringsBundle.getString('Alert11') + " \"sudo chmod u+s /sbin/shutdown\" ");
			document.getElementById('Sd.Option.setButton').disabled = false;
			document.getElementById('Sd.Option.IMG').src = "";
		}
			
	},
	setDefaultCommand: function(){
		document.getElementById('Sd.Option.txtShCommand').value=document.getElementById('Sd.Option.lstOs').value;
	},
	saveExecute: function() {
	
		var index = document.getElementById('Sd.Option.radiogroup').selectedIndex;
		if (index == 0)
			auto_shutdown_options_pref.WriteStr ('ShellCMD4',document.getElementById('Sd.Option.txtShCommand').value);
		else
			auto_shutdown_options_pref.WriteStr ('ShellCMD4-IDLE',document.getElementById('Sd.Option.txtShCommand').value);
	
		window.openDialog( 'chrome://inbshutdown/content/Shutdown.xul','Shutdown :: InBasic','centerscreen, chrome, resizable', index ).focus();
	},
	save: function() {
	
		var index = document.getElementById('Sd.Option.radiogroup').selectedIndex;
		if (index == 0)
			auto_shutdown_options_pref.WriteStr ('ShellCMD4',document.getElementById('Sd.Option.txtShCommand').value);
		else
			auto_shutdown_options_pref.WriteStr ('ShellCMD4-IDLE',document.getElementById('Sd.Option.txtShCommand').value);
	},
	
	insert: function(sInsert) {
	   const txtArgs=document.getElementById("Sd.Option.txtShCommand")
	   var selStart=txtArgs.selectionStart;
	   var selEnd=txtArgs.selectionEnd;
	   txtArgs.value=txtArgs.value.substring(0,selStart)+sInsert+txtArgs.value.substring(selEnd);
	   txtArgs.selectionStart=txtArgs.selectionEnd=selStart+sInsert.length;
	},
	openLink: function(URL) {
	   var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
			   .getService(Components.interfaces.nsIWindowMediator);
	   var win = wm.getMostRecentWindow("navigator:browser");
	   var gBrowser = win.getBrowser();
	   gBrowser.loadOneTab(URL, null, null, null, false, false);
	}	
}

var auto_shutdown_options_pref = {
	ReadBool: function(id) {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"]
		  .getService(Components.interfaces.nsIPrefService).getBranch("InBasic.ShutDown.");
		var str = prefs.getBoolPref(id);
		return str;
	},
	
	ReadStr: function(id) {
		if(id=="deactivateIDE")
		{
			var prefs = Components.classes["@InBasic.org/AutoShutdown/component;1"]
							 .getService().wrappedJSObject;
			return prefs.deactivateIDE();
		}
		else
		{
			var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("InBasic.ShutDown.");
			
			if ((id == 'ShellCMD4-IDLE') || (id == 'ShellCMD4') || (id == 'UserCMD2') || (id == 'UserCMD1') )
				var str = prefs.getComplexValue(id, Components.interfaces.nsISupportsString).data;
			else
				var str = prefs.getCharPref(id);
			return str;
		}
	},

	WriteBool: function(id,sData) {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"]
		  .getService(Components.interfaces.nsIPrefService).getBranch("InBasic.ShutDown.");
			prefs.setBoolPref(id, sData);
	},

	WriteStr: function(id,sData) {
        var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                              .getService(Components.interfaces.nsIPrefService).getBranch("InBasic.ShutDown.");
        if ((id == 'ShellCMD4-IDLE') || (id == 'ShellCMD4') || (id == 'UserCMD2') || (id == 'UserCMD1') ) {
			var str = Components.classes["@mozilla.org/supports-string;1"]
						        .createInstance(Components.interfaces.nsISupportsString);
            str.data=sData;
            prefs.setComplexValue(id, Components.interfaces.nsISupportsString, str);
        } 
		else 
            prefs.setCharPref(id, sData);
	}
}











